{ File Encryptor / Decryptor
  (C) 2006-2012, Andreas Berg. All Rights Reserved. }
program decrypt;

uses
 Crt, SysUtils, _common, _ecommon, _dcrypt, _pbar;

const
 CurVer            = '0.01';

var
 i                 : integer;
 s                 : string;
 err               : boolean;
 f                 : boolean;
 canWrite          : boolean;
 c                 : char;


function ReadPass: string;
var
 p                 : string;
 c                 : char;
 x, y              : integer;
begin
   p:= '';
   while true do begin
      repeat
      until keypressed;
      c:= ReadKey;
      if c = #13 then break;
      if c = #8 then begin
         if p <> '' then begin
            x:= WhereX;
            y:= WhereY;
            p:= copy(p, 1, length(p)-1);
            if x = 1 then begin
               dec(y);
               x:= 81;
            end;
            gotoxy(x-1, y);
            Write(' ');
            gotoxy(x-1, y);
         end;
      end else begin
         Write('*');
         p:= p + c;
      end;
   end;
   WriteLn('');
   ReadPass:= p;
end;



begin
   Write('File Decryptor ' + CurVer);
   WriteLn(' / (C) 2006-2012, Andreas Berg. All Rights Reserved.');

   if ParamCount = 0 then begin
      WriteLn('usage:  decrypt  input-file  [options]  [to directory]');
      WriteLn('');
      WriteLn('OPTION              DESCRIPTION');
      Writeln(' -p:<password>      Set Password');

      Writeln('');
   end else begin
      WriteLn('');
      CmdIFile:= '';
      CmdOFile:= '';
      CmdPwd:= '';
      ndir:= '';
      err:= false;

      for i:= 1 to ParamCount do begin
         s:= ParamStr(i);
         if s[1] = '-' then begin
            f:= false;
            if UpperCase(copy(s, 1, 3)) = '-P:' then begin
               CmdPwd:= copy(s, 4, length(s) - 3);
               f:= true;
            end;

            if not f then begin
               Writeln('ERROR: Invalid option [' + s + ']!');
               err:= true;
            end;
         end else begin
            if CmdIFile = '' then
             CmdIFile:= ParamStr(i)
            else begin
               if CmdOFile = '' then
                CmdOFile:= ParamStr(i)
               else begin
                  Writeln('ERROR: Input file and output directory already set!');
                  err:= true;
               end;
            end;
         end;
      end;

      if not err then begin
         if FileExists(CmdIFile) then begin

            efile:= CmdIFile;

            {$I-}
            Assign(fff, efile);
            Reset(fff);

               hdr:= ReadStringN(8);
               if hdr = 'BEF_0001' then begin

                  slen:= FileSize(fff);

                  for i:= 1 to 28 do
                   maskBuf[i]:= ReadWord;

                  newFile:= '';
                  BlockRead(fff, eBuf[0], 256);
                  DoDecrypt(256, 1);
                  for i:= 1 to eBuf[0] do begin
                     newFile:= newFile + chr(eBuf[i]);
                  end;

                  pwd:= '';
                  BlockRead(fff, eBuf[0], 256);
                  DoDecrypt(256, 2);
                  for i:= 1 to eBuf[0] do begin
                     pwd:= pwd + chr(eBuf[i]);
                  end;

                  ndir:= CmdOFile;
                  if ndir <> '' then begin
                     if copy(ndir, length(ndir), 1) <> dirSep then
                      ndir:= ndir + dirSep;
                  end;

                  if (pwd <> '') and (CmdPwd = '') then begin
                     Write('Password: ');
                     CmdPwd:= ReadPass;
                     WriteLn('');
                  end;

                  if pwd = CmdPwd then begin
                     canWrite:= true;
                     if FileExists(ndir + newFile) then begin
                        canWrite:= false;
                        Write('Do you want to overwrite [' + ndir + newFile + '] Y/n? ');
                        repeat
                        until keypressed;
                        c:= readkey;
                        WriteLn(c);
                        WriteLn('');
                        if upcase(c) = 'Y' then canWrite:= true;
                     end;

                     if canWrite then begin
                        Write('Decrypting: ');
                        BarX:= WhereX;
                        BarY:= WhereY;

                        IsRunEnc:= true;
                        RunDecrypt;

                        Writeln;
                        WriteLn('');
                        WriteLn('*** DONE ***');
                        WriteLn('');

                     end else begin
                        Close(fff);
                     end;
                  end else begin
                     WriteLn('ERROR: Invalid Password!');
                     Close(fff);
                  end;

               end else begin
                  WriteLn('ERROR: This is not a valid Encrypted file [' + efile + ']!');
                  Close(fff);
               end;

            {$I+}

         end else begin
           if CmdIFile <> '' then
            WriteLn('ERROR: File not found [' + CmdIFile + ']!')
           else
            WriteLn('ERROR: No File to decrypt!');
         end;

      end;

   end;
end.

