; LOCAL and GLOBAL Mode
; (C) 2007, Andreas Berg. All Rights Reserved.

.globalmode                            ; Set GLOBAL mode

asc = 65                               ; asc will be defined in the Global List
local asc                              ; asc will now be transfered to the Local List


.model             small               ; SMALL model
.stack             100h                ; 100h STACK
.data                                  ; Use DATA segment
message    db "CHARACTER = [ ", asc, " ]",13,10, "$"

.code                                  ; Use CODE segment
mov        ax,@data                    ; AX = @data
mov        ds,ax                       ; DS = AX

mov        dx,offset message           ; DX -> message
mov        ah,9                        ; AH = 9 (Print String)
int        21h                         ; INT 21h


mov        ah,4ch                      ; AH = 4ch (Terminate EXE)
mov        al,0                        ; AL = 0 (return code)
int        21h                         ; INT 21h: Terminate program

end
